package com.taauav.admin.dto;

import com.fasterxml.jackson.annotation.JsonIgnore;
import lombok.Data;

import java.math.BigInteger;
import java.util.HashMap;
import java.util.Map;

/**
 * <p>河道任务基础DTO</p>
 *
 * @author : dyg
 * @date : 2019-11-25 13:42
 **/
@Data
public class BaseInspectDriverDTO {

    private Integer id;

    /**
     * 巡检任务ID
     */
    private String inspectNo;

    /**
     * 行号(以10的倍数递增)
     */
    private Integer num;

    /**
     * 河道ID
     */

    private Integer driverId;

    /**
     * 河流名称
     */

    private String driverName;
    /**
     * 河流名称
     */
    private String driverAreaText;
    /**
     * 河流区域ID
     */
    private BigInteger driverArea;

    /**
     * 报告id
     */
    private Integer reportId;

    /**
     * 状态类型
     *
     * @return
     */
    @JsonIgnore
    public Map<Integer, String> getStatusList() {
        Map<Integer, String> map = new HashMap<>();
        map.put(1, "待分配");
        map.put(2, "待执行");
        map.put(3, "执行中");
        map.put(4, "已完成");
        map.put(5, "复核中");
        map.put(6, "复核完成");
        return map;
    }
}
