package com.taauav.admin.dto;

import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

import java.math.BigInteger;
import java.util.Date;
import java.util.HashMap;
import java.util.Map;

/**
 * <p>报告DTO基类</p>
 *
 * @author : dyg
 * @date : 2019-11-30 10:37
 **/
@Data
public class BaseReportDTO {
    private Integer id;

    private String reportNo;

    private Integer num;

    private Integer inspectDriverId;

    private String inspectNo;
    private String driverName;

    private BigInteger driverArea;

    private String driverAreaText;

    private String driverStart;

    private String driverEnd;
    /**
     * 巡检时间
     */
    @DateTimeFormat(pattern = "yyyy-MM-dd")
    @JsonFormat(pattern = "yyyy-MM-dd")
    private Date inspectTime;
    private String formatInspectTime;

    /**
     * 状态列表
     *
     * @return
     */
    public Map<Integer, String> getStatusList() {
        Map<Integer, String> map = new HashMap<>();
        map.put(1, "待生成");
        map.put(2, "审核中");
        map.put(3, "审核通过");
        map.put(4, "审核驳回");
        return map;
    }
}
