package com.taauav.admin.entity;

import java.math.BigInteger;
import java.util.Date;

import com.fasterxml.jackson.annotation.JsonFormat;
import com.taauav.common.domain.Entity;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;
import org.hibernate.validator.constraints.Length;
import org.springframework.format.annotation.DateTimeFormat;

import javax.validation.constraints.NotBlank;

/**
 * <p>
 * 外包人员表
 * </p>
 *
 * @author dyg
 * @since 2020-04-01
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
public class LsAdmin extends Entity {

    private static final long serialVersionUID = 1L;

    /**
     * 姓名
     */
    @NotBlank(message = "姓名不能为空")
    @Length(min = 2, max = 20, message = "姓名长度为2-20")
    private String realname;

    /**
     * 用户名
     */
    private String username;

    /**
     * 密码
     */
    private String password;

    /**
     * 头像
     */
    private String avatar;

    /**
     * 性别：1男 2女 3未知
     */
    private Integer gender;

    /**
     * 联系方式（手机号码）
     */
    private String mobile;

    /**
     * 邮箱
     */
    private String email;

    /**
     * 河长等级
     */
    private Integer level;

    /**
     * 区划ID
     */
    private BigInteger driverArea;

    /**
     * 职务
     */
    private String duty;

    /**
     * 角色编号
     */
    @NotBlank(message = "角色编号不能为空")
    private String authGroup;

    /**
     * Session标识
     */
    private String token;

    /**
     * 备注
     */
    private String note;

    /**
     * 登录次数
     */
    private Integer loginNum;

    /**
     * 上次登录IP
     */
    private Long lastIp;

    /**
     * 上次登录时间
     */
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date lastTime;

    /**
     * 排序
     */
    private Integer sort;

}
