package com.taauav.admin.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;

import java.io.Serializable;

import com.taauav.common.domain.Entity;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;
import org.hibernate.validator.constraints.Length;

import javax.validation.constraints.NotBlank;
import javax.validation.constraints.NotEmpty;
import javax.validation.constraints.NotNull;

/**
 * <p>
 * 挂载设备表
 * </p>
 *
 * @author dyg
 * @since 2020-04-01
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
public class TauvMountEquipment extends Entity {

    private static final long serialVersionUID = 1L;

    /**
     * 设备名称
     */
    @NotBlank(message = "设备名称不能为空")
    @Length(min = 2, max = 150, message = "设备名称长度2-150")
    private String name;

    /**
     * 设备编号
     */
    private String equipmentSn;

    /**
     * 品牌
     */
    @NotBlank(message = "品牌不能为空")
    @Length(max = 100, message = "品牌长度不超过100")
    private String brand;

    /**
     * 型号
     */
    @Length(max = 100, message = "型号长度不超过100")
    private String model;

    /**
     * 类型：1摄像 2其他
     */
    @NotNull(message = "请选择设备类型")
    private Integer type;

    /**
     * 备注
     */
    @Length(max = 255, message = "备注最大长度为255")
    private String note;


}
