package com.taauav.admin.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;

import java.io.Serializable;
import java.util.HashMap;
import java.util.Map;

import com.taauav.common.domain.Entity;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;
import org.hibernate.validator.constraints.Length;

import javax.validation.constraints.NotEmpty;

/**
 * <p>
 * 报告描述(评价)内容管理表
 * </p>
 *
 * @author dyg
 * @since 2019-11-14
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
public class TauvReportEvaluation extends Entity {

    private static final long serialVersionUID = 1L;

    /**
     * 评价内容
     */
    @NotEmpty(message = "请输入评价数据")
    @Length(min = 2, max = 200, message = "评价内容长度为2-200字")
    private String content;

    /**
     * 备注
     */
    @Length(max = 200, message = "备注长度不能超过200字")
    private String note;

    /**
     * 排序
     */
    private Integer sort;

    public Map<Integer, String> getStatusList() {
        Map<Integer, String> map = new HashMap<>(2);
        map.put(1, "正常");
        map.put(2, "禁用");
        return map;
    }

}
