package com.taauav.common.util;

import com.taauav.common.bean.Menu;

import java.util.ArrayList;
import java.util.List;

/**
 * 创建属性结构MenuTree
 * @author dyg
 * @date 2019/11/12
 */
public class MenuTree {

    private List<Menu> menuList = new ArrayList<>();

    public MenuTree(List<Menu> menuList) {
        this.menuList = menuList;
    }

    /**
     * 建立树形结构
     * @return
     */
    public List<Menu> buildTree() {
        List<Menu> treeMenu = new ArrayList<>();
        for (Menu menuNode : getRootNode()) {
            menuNode = buildChildTree(menuNode);
            treeMenu.add(menuNode);
        }
        return treeMenu;
    }

    /**
     * 递归建立子树形结构
     * @param pNode
     * @return
     */
    private Menu buildChildTree(Menu pNode) {
        List<Menu> childMenus = new ArrayList<>();
        for (Menu menuNode : menuList) {
            if (menuNode.getParentId().equals(pNode.getId())) {
                childMenus.add(buildChildTree(menuNode));
            }
        }
        pNode.setChilren(childMenus);
        return pNode;
    }

    /**
     * 获取根节点
     * @return
     */
    private List<Menu> getRootNode() {
        List<Menu> rootMenuLists = new ArrayList<>();
        for (Menu menuNode : menuList) {
            if (menuNode.getParentId().equals("0")) {
                rootMenuLists.add(menuNode);
            }
        }
        return rootMenuLists;
    }
}
